\section{Introduction}

The Sokoban puzzle is a simple board game that consists of a series
of jewels and a man that is able to push the jewels around. The jewels
are being moved around in a grid which is constrained by walls - and
that also includes the man off course.

In order for the game to be complete, each jewel much be placed at
predefined goals. This may sound trivial, but it's not as we will
see later. The position of a single jewel can easily block the path
for another jewel and must therefore be planned for.

At the very beginning of the project, and considering the different
arguments of the group's members, we decided to build two planners;
one programmed in C++ and another programmed in C\#. By doing it,
we were going to be able to perform a comparison based on performance,
and maybe on effort.

When building the planners we did not simply translate the algorithms between
different languages, but we also tried to take advantage of the particularities
of each language: even if it requires little modifications in the specific
model of the problem. Further, we could avoid to spread specific implementation
related errors between the two planners.

In the sections \ref{Cpp-planner} and \ref{Csharp-planner}, where we describe the planners,
we are going to focus on the parts of the implementation that brought us more troubles.
As we will see, these particularites are very different, considering the use of languages
with different advantages and disadvantages.

{\color{red}KALYAN SPEAK SOMETHING ABOUT THE AGENT\ldots}


\section{Model of the Problem}

It was from the beginning clear that the problem should be represented
as a state-space problem. But a problem like this is difficult to
comprehend without splitting it into smaller subproblems. In that
way we could make a system that could focus on specific problems without
getting to overburdened.

Therefore, we decided to split the main problem in two subproblems:
the jewel problem and the man problem.


\subsection{Jewel problem}

If we analyse the game without the man, we can assume a series of
things. In basic, the players of the game are the jewels. The jewels
have a basic way of moving: vertically or horizontally. Furthermore it
is only possible to move a single jewel at a time, one cell at a time.
All jewels are free to move everywhere in the grid, as long as it
can access free cells.

But how can we guarantee if we can move to another cell? A little
foresight is good: When we at a later time expect to see the man push
the jewel around, there must be enough room for the man to be placed
behind the jewel. Conclusion: for a jewel to move from one cell to
the next, there must be both a free cell both in front and behind
the jewel. 

So, when we formulate the problem by the state-space definition, it turns
out like this:

\begin{description}
\item [Initial state] Starting position of the jewels from the
  beginning of the game.
\item [Successor function] Build successor nodes of each possible movement
  - possible only when the cell in front and back are both free.
\item [Goal test] The games succeeds when all the jewels are placed at
  the different goal positions - without concerning the order of the
  placement. 
\item [Path cost] The heuristics are made simply by using the predefined
  Manhattan distance\footnote{The Manhattan distance is originally from the
  square streets of the Manhattan island - the number of vertical and
  the number of horizontal streets to the goal.}
\end{description} 

By now we have talked about heuristics, so it would also be reasonable
to state that an informed algorithm is in use to solve the problem
here. The heuristics has only been handled scarcely, but as a good
heuristic has certain properties, we must take a look at how it
works.

The AIMA book describes in detail that the heuristics should be admissive
since otherwise it would not guarantee that the solution would
be optimal. On the other hand even though the heuristics should be admissive,
its also better to have a result that is as close to the
actual result as possible, since if the heuristics are to low, the
algorithm will try to expand a lot of the wrong nodes also and thereby
make it resemble a breath-first algorithm.

In our scenario, the shortest distance is merely the sum of all the
Manhattan-distances for each jewel - plus the distance the man has to
take if he has to switch to another jewel.

\subsection{Man-problem}

By now we have a definition of the movements of the system, which
includes some vague representations of the movements of the man when
its attached to an specific jewel. Now we have to look a little closer
into the problem of actually moving the man from one jewel to another
or just moving the man from one side of the jewel to another on order
to let the jewel be pushed in the right direction.

So, therefore, we may test each situation from our jewel problem which
would demand a switch of jewel being pushed.

In order to solve this, its easy to define the problem of the man as
new state-space problem that is able to bring the man from one
position to another.

\begin{description}
  \item[Initial state] An initial position from where we have to move
    the man.

\item[Successor function] Expands nodes representing all the different
  free cells around the man in the present node - plus it also makes
  sure that the man is facing the right way.

\item[Goal test] The man at the destiny position - behind some jewel.

\item[Path cost] Each step of the man adds one to the path cost - plus one if
  the man has to change to another direction.
\end{description}

In the case of the C++ planner, we chose to represent the same information about the man in the same
node structure as the jewels. This demands that the structure must be
able to reflect man position and current direction of the man as well.

\subsection{The problem as a whole}

Our first idea of this problem was that we should try to implement the
testing of the man-problem after we have solved the
jewel-problem. This means that the jewel-problem would deliver a
complete solution in which we would search for situations where the
man had to be moved to another position in order to continue the
jewel-problem. If the man was not able to perform all the different
moves, the jewel-problem would be rolled back to the last position
that the man was able to move to and told to continue from there.

There was a drawback to this choice since the cost of the man could
not be put into the jewel-problem meaning that the solution would not
be optimal - but since the amount of times the man-problem would have
to be processed was limited to testing only for moves the
jewel-problem has guessed would work, the time to solve the entire
puzzle would be fairly good.

From an entire architectural view-point this was good since we could
build the two problems without having them to know of each other.

We implemented this idea and tested it on some simpler problems in
which it worked well - but it seemed that it was difficult to let the
problem scale to many jewels - it simply failed when we would have a
problem with more than two jewels.

We decided to abandon this idea fairly early in the process since we
newer where quite keen on the fact that the solution would newer be
optimal and we believed that making an optimal solution would be the
best way to go.

So instead of going any further with the initial idea, we decided that
the man should be tested more closely with the jewel-problem.

That meant that each time we had to try to move a man to a jewel
different than the previous one, we would make a switch to solve the
man-problem for that movement. This had the advantage that we could
add the path cost of the man directly to the jewel-problem and therefore
have a precise step cost each time. This would lead to an optimal solution
in the end.

The functionality for this was implemented in the successor function.
